// -*- c++ -*-
// ****************************************************************************
//  Name: common-config.h
//  Athr: Michael D. Beynon : (mdb) - beynon@cs.umd.edu
//  Date: 10/18/1999 : mdb - Created.
//        12/03/2000 : mdb - Reorganized using gnu autoconf's configure.
//  Desc: Platform and/or compiler specific configuration settings.
//  Note: The file config.h is generated from config.h.in by configure.
//        config.h.in is generated by autoheader.  This common.h header
//        is simply a wrapper for handling the settings. 
// ****************************************************************************

#if !defined(H_COMMON_CONFIG)
#define H_COMMON_CONFIG


// include the results from all the configure tests
#if HAVE_CONFIG_H
#include "config.h"
#endif

// turns on possible debugging messages
#define DCDBG

#ifdef _WIN32
#define HAVE_INSTANTIATIONS
#else
// bool datatype
#if !defined(HAVE_BOOL)
//typedef int bool;
#define true  1
#define false 0
#endif

#endif

// c++ new style casts
#if defined(HAVE_STATIC_CAST)
#  define static_cast(type,value)      static_cast<type>(value)
#else
#  define static_cast(type,value)      (type)(value)
#endif
#if defined(HAVE_DYNAMIC_CAST)
#  define dynamic_cast(type,value)     dynamic_cast<type>(value)
#else
#  define dynamic_cast(type,value)     (type)(value)
#endif
#if defined(HAVE_CONST_CAST)
#  define const_cast(type,value)       const_cast<type>(value)
#else
#  define const_cast(type,value)       (type)(value)
#endif
#if defined(HAVE_REINTERPRET_CAST)
#  define reinterpret_cast(type,value) reinterpret_cast<type>(value)
#else
#  define reinterpret_cast(type,value) (type)(value)
#endif


#endif /* H_COMMON_CONFIG */
// ****************************************************************************
