// ****************************************************************************
//  Name: dc_buffer.cpp
//  Athr: Michael D. Beynon (mdb)
//  Date: 02/26/2001 : mdb - Created.
//  Desc: DataCutter buffer class.
// ****************************************************************************

#include "dc_buffer.h"

DC_Buffer_t::DC_Buffer_t(const DC_Buffer_t &buf)
  : eType(buf.eType), fConsume(true) {
  DeepCopy(buf);
}

ostream &operator<<(ostream &os, DC_Buffer_t &buf) {
  switch (buf.eType) {
  case DC_Buffer_t::DATA:
    os << "DC_Buffer{DATA:"
       << "" << buf.getSize()
       << "/" << buf.getMax()
       << ",fFree=" << (buf.fFree ? 't' : 'f')
       << ",0x" << std::hex << (long)buf.pBuf << std::dec
       << '}';
    break;
  case DC_Buffer_t::EOW:
    os << "DC_Buffer{EOW"
       << ",0x" << std::hex << (long)buf.pBuf << std::dec
       << '}';
    break;
  case DC_Buffer_t::EOS:
    os << "DC_Buffer{EOS"
       << ",0x" << std::hex << (long)buf.pBuf << std::dec
       << '}';
    break;
  }
  return os;
}


// ****************************************************************************
