// ****************************************************************************
//  Name: dc_error.cpp
//  Athr: Michael D. Beynon (mdb)
//  Date: 08/12/2000 : mdb - Created.
//  Desc: DataCutter Filter Service user library.
// ****************************************************************************

#include "dc_error.h"

char *DC_strerror(int err) {
  switch (err) {
  case DC_ERR_OK:
    return "DC_ERR_OK: No error.";
    break;
  case DC_ERR_Error:
    return "DC_ERR_Error: General error.";
    break;
  case DC_ERR_NotConsoleProcess:
    return "DC_ERR_NotConsoleProcess: operation allowed only in a console process.";
    break;
  case DC_ERR_NotRemoteProcess:
    return "DC_ERR_NotRemoteProcess: operation allowed only in a remote process.";
    break;
  case DC_ERR_InstanceNotRunning:
    return "DC_ERR_InstanceNotRunning: cannot append work to a non-running instance.";
    break;
  case DC_ERR_RemoteInstanceError:
    return "DC_ERR_RemoteInstanceError: error adding work to one of the remote instances.";
    break;
  case DC_ERR_InvalidLayout:
    return "DC_ERR_InvalidLayout: layout is not logically complete.";
    break;
  case DC_ERR_InvalidPlacement:
    return "DC_ERR_InvalidPlacement: cannot execute using an invalid placement.";
    break;
  case DC_ERR_AppdCommFailed:
    return "DC_ERR_AppdCommFailed: remote processes could not be started.";
    break;
  case DC_ERR_RemoteProcessCommFailed:
    return "DC_ERR_RemoteProcessCommFailed: unable to send instance execute command.";
    break;
  case DC_ERR_FailedConnect:
    return "DC_ERR_FailedConnect: unable to open a connection to the remote process.";
    break;
  case DC_ERR_FailedWrite:
    return "DC_ERR_FailedWrite: write to the connection failed, closing the stream.";
    break;
  case DC_ERR_RemoteFailThreadCreate:
    return "DC_ERR_RemoteFailThreadCreate: could not start a new thread for remote filter.";
    break;
  case DC_ERR_RemoteFailObjCreate:
    return "DC_ERR_RemoteFailObjCreate: remote filter factory function returned NULL.";
    break;
  case DC_ERR_RemoteFilterFail:
    return "DC_ERR_RemoteFilterFail: remote filter failure getting work.";
    break;
  case DC_ERR_InvalidWorkHandle:
    return "DC_ERR_InvalidWorkHandle: work handle not result of appending work.";
    break;
  case DC_ERR_WorkInProgress:
    return "DC_ERR_WorkInProgress: work has not finished ... use Wait() instead.";
    break;
  case DC_ERR_NoWorkFound:
    return "DC_ERR_NoWorkFound: no qualifying work is found to wait for.";
    break;
  case DC_ERR_StreamEndOfWork:
    return "DC_ERR_StreamEndOfWork: stream operation disallowed until next unit of work.";
    break;
  case DC_ERR_StreamEndOfStream:
    return "DC_ERR_StreamEndOfStream: stream operation disallowed on a closed stream.";
    break;
  case DC_ERR_InvalidBuffer:
    return "DC_ERR_InvalidBuffer: the buffer given is invalid (perhaps NULL).";
    break;
  case DC_ERR_InvalidStreamName:
    return "DC_ERR_InvalidStreamName: the given stream name was not found.";
    break;
  case DC_ERR_InsSelectAllShutdown:
    return "DC_ERR_InsSelectAllShutdown: all input streams are shutdown (EOS).";
    break;
  case DC_ERR_WorkFail:
    return "DC_ERR_WorkFail: work was not completed successfully.";
    break;
  case DC_ERR_InstanceFail:
    return "DC_ERR_InstanceFail: remote filters in instance have been shut down.";
    break;
  default:
    return "DC_ERR_<unknown>: unknown error.";
    break;
  }
}


// ****************************************************************************
