// -*- c++ -*-
// ****************************************************************************
//  Name: dc_error.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 08/10/2000 : mdb - Created.
//  Desc: DataCutter Filter Service user library.
// ****************************************************************************
/** @file dc_error.h */

#if !defined(H_DC_ERROR)
#define H_DC_ERROR

#define DC_ERR_OK			0
#define DC_ERR_Error			-1
#define DC_ERR_NotConsoleProcess	-2
#define DC_ERR_NotRemoteProcess		-3
#define DC_ERR_InstanceNotRunning	-4
#define DC_ERR_RemoteInstanceError	-5
#define DC_ERR_InvalidLayout		-6
#define DC_ERR_InvalidPlacement		-7
#define DC_ERR_AppdCommFailed		-8
#define DC_ERR_RemoteProcessCommFailed	-9
#define DC_ERR_FailedConnect		-10
#define DC_ERR_FailedWrite		-11
#define DC_ERR_RemoteFailThreadCreate	-12
#define DC_ERR_RemoteFailObjCreate	-13
#define DC_ERR_RemoteFilterFail		-14
#define DC_ERR_InvalidWorkHandle	-15
#define DC_ERR_WorkInProgress		-16
#define DC_ERR_NoWorkFound		-17
#define DC_ERR_StreamEndOfWork		-18
#define DC_ERR_StreamEndOfStream	-19
#define DC_ERR_InvalidBuffer		-20
#define DC_ERR_InvalidStreamName	-21
#define DC_ERR_InsSelectAllShutdown	-22
#define DC_ERR_WorkFail                 -23
#define DC_ERR_InstanceFail             -24

extern char *DC_strerror(int err);

#endif /* H_DC_ERROR */
// ****************************************************************************
