// ****************************************************************************
//  Name: dc_filterlayout.cpp
//  Athr: Michael D. Beynon (mdb)
//  Date: 10/01/2000 : mdb - Created.
//  Desc: Functions for adding filter layout from code.
// ****************************************************************************
#include "dc_filterlayout.h"
#include "dc_error.h"

#include <stdio.h>

#ifdef _WIN32
#include "win32.h"
#endif

/**
 * ctor
 */
DC_FilterLayout_t::DC_FilterLayout_t(void) : sbName(NULL) {
}

/**
 * dtor
 */
DC_FilterLayout_t::~DC_FilterLayout_t(void) {
  Flush();
  if (sbName) delete [] sbName;
}

char *DC_FilterLayout_t::getName(void) {
  return sbName;  // may be NULL
}

void DC_FilterLayout_t::setName(char *sbName_in) {
  if (sbName) delete [] sbName;
  sbName = StrDup(sbName_in);
}

int DC_FilterLayout_t::Add(char *sbFilterName,
			   char *sbInsList, char *sbOutsList,
			   bool fAllowCopies) {
  unsigned int iSection;
  char buf[80];

  snprintf(buf, sizeof(buf), "filter.%s", sbFilterName);
  iSection = AddSection(buf);
  if (sbInsList)  AddEntry(iSection, "ins", sbInsList);
  if (sbOutsList) AddEntry(iSection, "outs", sbOutsList);
  if (!fAllowCopies) AddEntry(iSection, "copies", "no");
  return DC_ERR_OK;
}


// ****************************************************************************

