// -*- c++ -*-
// ****************************************************************************
//  Name: dc_filterlayout.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 08/10/2000 : mdb - Created.
//  Desc: DataCutter Filter Service user library.
// ****************************************************************************
/** @file dc_filterlayout.h */

#if !defined(H_DC_FILTERLAYOUT)
#define H_DC_FILTERLAYOUT

#include "lib/dc_standard.h"
#include "lib/dc_configinfo.h"


/**
 * allows for in-code creation of placement for a set of filters,
 * instead of reading it from an external file.
 */
class DC_FilterLayout_t : public ConfigInfo {
protected:
  char *sbName;
public:
  DC_FilterLayout_t(void);
  ~DC_FilterLayout_t(void);

  /// gets the symbolic name for the layout
  char *getName(void);  // may be NULL if no name given
  /// sets the symbolic name for the layout
  void setName(char *sbName_in);

  // BUGBUG: this will be a problem when we start annotating the
  // layout with cost model info.  Maybe better would be to store the
  // annotations somewhere else, and load them into the dird as
  // [costmodel."appname"."filtername"] foo=bar
  int Add(char *sbFilterName, char *sbInsList, char *sbOutsList,
	  bool fAllowCopies=true);
};


#endif /* H_DC_FILTERLAYOUT */
// ****************************************************************************
