// ****************************************************************************
//  Name: dc_placement.cpp
//  Athr: Michael D. Beynon (mdb)
//  Date: 08/09/2000 : mdb - Created.
//  Desc: DataCutter Filter Service user library.
// ****************************************************************************

#include "dc_placement.h"

#ifdef _WIN32
#include "win32.h"
#endif

/**
 * ctor
 */
DC_Placement_t::DC_Placement_t(void) : fProcessed(false) {
}
/**
 * dtor
 */
DC_Placement_t::~DC_Placement_t(void) {
  Flush();
}

/**
 * sbHostName - "<one_per_node>" == assign filters RR to running appds
 */
void DC_Placement_t::Add(char *sbFilterName, char *sbHostName,
			 int nCopiesLow, int nCopiesHigh) {
  const int maxBuf = 80;
  char buf[maxBuf];
  if (nCopiesLow == -1 && nCopiesHigh == -1) {
    snprintf(buf, maxBuf, "%s", sbHostName);
  } else if (nCopiesHigh == -1) {
    snprintf(buf, maxBuf, "%s %d", sbHostName, nCopiesLow);
  } else {
    snprintf(buf, maxBuf, "%s %d %d", sbHostName, nCopiesLow, nCopiesHigh);
  }
  AddEntry("placement", sbFilterName, buf);
}

void DC_Placement_t::AddWritePolicy(char *sbStreamName, char *sbSourceRe,
				    char *sbSinkRe, char *sbPolicy) {
  const int maxBuf = 80;
  char buf[maxBuf];
  snprintf(buf, maxBuf, "write %s %s %s", sbSourceRe, sbSinkRe, sbPolicy);
  AddEntry("placement", sbStreamName, buf);
}


// ****************************************************************************
