// -*- c++ -*-
// ****************************************************************************
//  Name: dc_placement.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 08/09/2000 : mdb - Created.
//  Desc: DataCutter Filter Service user library.
// ****************************************************************************
/** @file dc_placement.h */

#if !defined(H_DC_PLACEMENT)
#define H_DC_PLACEMENT

#include "lib/dc_standard.h"
#include "lib/dc_configinfo.h"


/**
 * allows for in-code creation of placement for a set of filters,
 * instead of reading it from an external file.
 */
class DC_Placement_t : public ConfigInfo {
protected:
  bool fProcessed;

public:
  DC_Placement_t(void);
  ~DC_Placement_t(void);

  // sbHostName - "<one_per_node>" == assign filters RR to running appds
  void Add(char *sbFilterName, char *sbHostName,
	   int nCopiesLow=-1, int nCopiesHigh=-1);
  void AddWritePolicy(char *sbStreamName, char *sbSourceRe, char *sbSinkRe,
		      char *sbPolicy);
};


#endif /* H_DC_PLACEMENT */
// ****************************************************************************
