// -*- c++ -*-
// ****************************************************************************
//  Name: dc_policy.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 04/25/2001 : mdb - Created.
//  Desc: 
// ****************************************************************************
/** @file dc_policy.h */

#if !defined(H_DC_POLICY)
#define H_DC_POLICY

#include "lib/dc_standard.h"

/**
 * control: buffer writes to a distributed stream buffer queue
 * defined by: [console] stream_write_policy = < RR | WRR | DD | UD >
 * changed to be defined by: [placement] stream = write src dst <policy> args
 */
typedef enum {
  DC_StreamWritePolicy_RR=0,
  DC_StreamWritePolicy_WRR,
  //  DC_StreamWritePolicy_SRR,  // scaled for number of processors and speed
  DC_StreamWritePolicy_DD,
  DC_StreamWritePolicy_UD
} DC_StreamWritePolicy_t;

extern const char *DC_StreamWritePolicy_tostr(DC_StreamWritePolicy_t ePolicy);
extern DC_StreamWritePolicy_t DC_StreamWritePolicy_toenum(char *sbPolicy);


#endif /* H_DC_POLICY */
// ****************************************************************************
