// -*- c++ -*-
// ****************************************************************************
//  Name: dc_work.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 08/10/2000 : mdb - Created.
//  Desc: DataCutter Filter Service user library.
// ****************************************************************************
/** @file dc_work.h */

#if !defined(H_DC_WORK)
#define H_DC_WORK

#include "dc_buffer.h"

#define WORK_DEFAULT_BUFFER_SIZE  (1024)

typedef int DC_WorkHandle_t;

/// Work definition
class DC_Work_t {
public:
  int wWorkNum;
  DC_Buffer_t buf;
public:
  DC_Work_t(void) : wWorkNum(-1) { buf.New(WORK_DEFAULT_BUFFER_SIZE); };
  DC_Work_t(int wBufSize) : wWorkNum(-1) { buf.New(wBufSize); };
  ~DC_Work_t(void) { buf.Delete(); };
};


#endif /* H_DC_WORK */
// ****************************************************************************
