// -*- c++ -*-
// ****************************************************************************
//  Name: hostinfo.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 04/12/2000 : mdb - Created.
//  Desc: 
// ****************************************************************************

#if !defined(H_DC_HOSTINFO)
#define H_DC_HOSTINFO

#include "lib/dc_standard.h"
#include "lib/dc_configinfo.h"

class HostInfo {
public:
  ConfigInfo cfg;

  /// Check if string matches the extended regular expression
  int re_match(const char *sbString, char *sbPattern);

public:
  int Init(void);
  int InitFromDird(char *sbHost=NULL, int wPort=0);
  int InitFromFile(char *sbFile);

  /// given a hostname, find the canonical name.
  char *CanonicalName_Alloc(char *sbHost, bool fGetHostByName=false);

  /// inputs are expected to be canonical hostnames
  char *ConnectName(char *sbHostFrom, char *sbHostTo);

  /// input is not expected to be a canonical hostname
  char *ConnectNameTo_Alloc(char *sbHostTo);

  /// assume "to host" is the host we are executing on
  char *ConnectNameFrom_Alloc(char *sbHostFrom);
};


#endif /* H_DC_HOSTINFO */
// ****************************************************************************
