package dc.jfilters;

/*
 * This is the base filter for a dc application.  Extend this and implement
 * the three abctract methods:
 * start_work a.k.a. init in C++)
 * processs (same in C++)
 * finish_work (finalize in C++)
 */

public abstract class DC_Filter_Base_t {
    //    SK: REPLACED INSTANCE VARIABLES WITH ACCESS METHODS
    public String getSbFilterName() {
        return _getSbFilterName();
    }

    public void setSbFilterName(String newSbFilterName) {
        _setSbFilterName(newSbFilterName);
    }
    //SK: END ADDED ACCESS METHODS

    //SK: THIS CLASS WILL BE CONSTRUCTED IN C++ AND SET UP WITH PROPER NATIVE REFERENCE

    //virtual ~DC_Filter_Base_t(void) { TestDelete(sbFilterName); };
    protected void finalize() {
    }

    //SK: OVERLOADED FUNCTIONS WITH DEFAULT PARAMETERS (NO DEFAULT VALUES IN JAVA)
    public String findAppFilterConfig(String sbName) {
        return findAppFilterConfig(sbName, -1);
    }

    public String findAppFilterConfig(String sbName, int wId) {
        return _findAppFilterConfig(sbName, wId);
    }

    //java does not support default values so overloaded function
    public long findAppFilterConfigInt(String sbName) {
        return findAppFilterConfigInt(sbName, -1, true);
    }

    public long findAppFilterConfigInt(String sbName, int wId) {
        return findAppFilterConfigInt(sbName, wId, true);
    }

    public long findAppFilterConfigInt(String sbName, int wId, boolean fInterpretUnits) {
        return _findAppFilterConfigInt(sbName, wId, fInterpretUnits);
    }

    //java does not support default values so overloaded function
    public double findAppFilterConfigDbl(String sbName) {
        return findAppFilterConfigDbl(sbName, -1);
    }

    public double findAppFilterConfigDbl(String sbName, int wId) {
        return _findAppFilterConfigDbl(sbName, wId);
    }

    // filter service provided methods
    public void FilterLock() {
        _filterLock();
    }

    public void FilterUnlock() {
        _filterUnlock();
    }

    // user-defined interface methods
    public abstract int start_work(initarg_t arg);
    public abstract int process(arg_t arg);
    public abstract int finish_work();


    //PRIVATE NATIVE FOUNDATION HERE
    //constructor to allow easy creation of this class from C++
    protected DC_Filter_Base_t() {
    }

    private native String _getSbFilterName();
    private native void _setSbFilterName(String newSbFilterName);

    private native String _findAppFilterConfig(String sbName, int wId);
    private native long _findAppFilterConfigInt(String sbName, int wId, boolean fInterpretUnits);
    private native double _findAppFilterConfigDbl(String sbName, int wId);
    private native void _filterLock();
    private native void _filterUnlock();
}
