package dc.jfilters;

public class DC_PipeOutStream_t {
    //SK: REMOVED FRIEND DEFINITIONS
    //friend class DC_RemoteProcessState;
    //friend class DC_RemoteFilterCopy;
    //friend class DC_Filter_Base_t::arg_t;
    
    public DC_PipeOutStream_t() {
        _initialize();
    }
    
    protected void finalize() {
        _delete();
    }
    
    public String getName() {
        return _getName();
    }
    
    //SK: REMOVED DISABLED FUNCTIONS
    //bool isColocated(void);  // disabled because of transparent copies
    //bool isDiffEndian(void); // disabled because of transparent copies
    
    public boolean isEndOfWork() {
        return _isEndOfWork();
    }
    
    public boolean isEndOfStream() {
        return _isEndOfStream();
    }
    
    // *** copy versions
    // write() does a deep copy before calling write_nocopy()
    //
    // *** no copy versions
    // write_nocopy() just uses the given buffer.  If colocated with the sink
    //   this will be deposited directly in that Queue.  If not colocated with
    //   the sink it is sent, and then consume'ed.
    //
    // pUserArg is used for the case of a user-defined stream write
    // policy.  This extra arg is passed to the policy.write_copyset()
    // callback to help decide where to send the buffer.  Typical use
    // will be for metadata.
    //
    // Be VERY careful using this version with local vars on the
    // stack, since it could be needed long after the write call
    // if we are colocated.
    //SK : REMOVED SINCE NO * or & in JAVA, ONLY REF
    //inline int write(DC_Buffer_t &buf, void *pUserArg=NULL)
    //SK: REMOVED VOID PARAMTER FOR NOW
    public int write(DC_Buffer_t pbuf) {
        return _write(pbuf);
    }
    
    // Be VERY careful using this version with local vars on the
    // stack, since it could be needed long after the write call
    // if we are colocated.
    //SK : REMOVED SINCE NO * or & in JAVA, ONLY REF
    //inline int write_nocopy(DC_Buffer_t &buf, void *pUserArg=NULL)
    //SK: REMOVED VOID PARAMETER FOR NOW
    public int write_nocopy(DC_Buffer_t pbuf) {
        return _write_nocopy(pbuf);
    }
    
    public int close() {
        return close(false);
    }
    
    public int close(boolean fEndOfWork) {
        return _close(fEndOfWork);
    }
    
    //PRIVATE NATIVE FOUNDATION HERE
    private native void _initialize();
    private native void _delete();
    
    private native String _getName();
    private native boolean _isEndOfWork();
    private native boolean _isEndOfStream();
    private native int _write(DC_Buffer_t pbuf);
    private native int _write_nocopy(DC_Buffer_t pbuf);
    private native int _close(boolean fEndOfWork);
}
