/* 
* This file provides the native implementation of the native methods defined 
* in DC_PipeInStream_t.java 
*/

#include <jni.h>
#include "dc_jfilters_DC_0005fPipeInStream_0005ft.h"
#include "util/dc_jnimap.h"
#include "reg/NativeReg.h"
#include "dc_filterservice.h"

/*
* Class:     dc_jfilters_DC_0005fPipeInStream_0005ft
* Method:    _initialize
* Signature: ()J
*/
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1PipeInStream_1t__1initialize
(JNIEnv *env, jobject thisJ) {
   DC_PipeInStream_t* newClass = new DC_PipeInStream_t();
   
   DC_JNIMap::GetJNIMap()->addPair(env, thisJ, reinterpret_cast<jlong>(newClass));
}

/*
* Class:     dc_jfilters_DC_0005fPipeInStream_0005ft
* Method:    _delete
* Signature: ()V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1PipeInStream_1t__1delete
(JNIEnv *env, jobject thisJ) {
   DC_JNIMap::GetJNIMap()->remove(env, thisJ);
}

/*
* Class:     dc_jfilters_DC_0005fPipeInStream_0005ft
* Method:    _getName
* Signature: ()Ljava/lang/String;
*/
JNIEXPORT jstring JNICALL Java_dc_jfilters_DC_1PipeInStream_1t__1getName
(JNIEnv *env, jobject thisJ) {
   DC_PipeInStream_t *thisC = reinterpret_cast<DC_PipeInStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   const char* result = const_cast<const char*>(thisC->getName());
   return env->NewStringUTF(result);
}

/*
* Class:     dc_jfilters_DC_0005fPipeInStream_0005ft
* Method:    _isEndOfWork
* Signature: ()Z
*/
JNIEXPORT jboolean JNICALL Java_dc_jfilters_DC_1PipeInStream_1t__1isEndOfWork
(JNIEnv *env, jobject thisJ) {
   DC_PipeInStream_t *thisC = reinterpret_cast<DC_PipeInStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   return static_cast<jboolean>(thisC->isEndOfWork());
}

/*
* Class:     dc_jfilters_DC_0005fPipeInStream_0005ft
* Method:    _isEndOfStream
* Signature: ()Z
*/
JNIEXPORT jboolean JNICALL Java_dc_jfilters_DC_1PipeInStream_1t__1isEndOfStream
(JNIEnv *env, jobject thisJ) {
   DC_PipeInStream_t *thisC = reinterpret_cast<DC_PipeInStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   return static_cast<jboolean>(thisC->isEndOfStream());
}

/*
* Class:     dc_jfilters_DC_0005fPipeInStream_0005ft
* Method:    _read
* Signature: ()Ldc/jfilters/DC_Buffer_t;
*/
JNIEXPORT jobject JNICALL Java_dc_jfilters_DC_1PipeInStream_1t__1read
(JNIEnv *env , jobject thisJ) {
   DC_PipeInStream_t *thisC = reinterpret_cast<DC_PipeInStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   //construct a new DC_Buffer_t in java with buff as the native reference
   jobject result = NULL;

   jvalue params[1];
   params[0].z = false;

   if (NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_Buffer_t", "(Z)V", params, result) == 1) {
      DC_JNIMap::GetJNIMap()->addPairNoOverwrite(env, result, reinterpret_cast<jlong>(thisC->read()));
   }
   
   return result;
}

/*
* Class:     dc_jfilters_DC_0005fPipeInStream_0005ft
* Method:    _close
* Signature: ()I
*/
JNIEXPORT jint JNICALL Java_dc_jfilters_DC_1PipeInStream_1t__1close
(JNIEnv *env , jobject thisJ) {
   DC_PipeInStream_t *thisC = reinterpret_cast<DC_PipeInStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   return static_cast<jint>(thisC->close());
}
