/* 
* This file provides the native implementation of the native methods defined 
* in DC_PipeOutStream_t.java 
*/

#include <jni.h>
#include "dc_jfilters_DC_0005fPipeOutStream_0005ft.h"
#include "util/dc_jnimap.h"
#include "dc_filterservice.h"

/*
* Class:     dc_jfilters_DC_0005fPipeOutStream_0005ft
* Method:    _initialize
* Signature: ()J
*/
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1PipeOutStream_1t__1initialize
(JNIEnv *env , jobject thisJ) {
   DC_PipeOutStream_t* newClass = new DC_PipeOutStream_t();
   
   DC_JNIMap::GetJNIMap()->addPair(env, thisJ, reinterpret_cast<jlong>(newClass));
}

/*
* Class:     dc_jfilters_DC_0005fPipeOutStream_0005ft
* Method:    _delete
* Signature: ()V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1PipeOutStream_1t__1delete
(JNIEnv *env, jobject thisJ) {
   DC_JNIMap::GetJNIMap()->remove(env, thisJ);
}

/*
* Class:     dc_jfilters_DC_0005fPipeOutStream_0005ft
* Method:    _getName
* Signature: ()Ljava/lang/String;
*/
JNIEXPORT jstring JNICALL Java_dc_jfilters_DC_1PipeOutStream_1t__1getName
(JNIEnv *env, jobject thisJ) {
   DC_PipeOutStream_t *thisC = reinterpret_cast<DC_PipeOutStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   const char* result = const_cast<const char *>(thisC->getName());
   
   return env->NewStringUTF(result);
}

/*
* Class:     dc_jfilters_DC_0005fPipeOutStream_0005ft
* Method:    _isEndOfWork
* Signature: ()Z
*/
JNIEXPORT jboolean JNICALL Java_dc_jfilters_DC_1PipeOutStream_1t__1isEndOfWork
(JNIEnv *env , jobject thisJ) {
   DC_PipeOutStream_t *thisC = reinterpret_cast<DC_PipeOutStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   return static_cast<jboolean>(thisC->isEndOfWork());
}

/*
* Class:     dc_jfilters_DC_0005fPipeOutStream_0005ft
* Method:    _isEndOfStream
* Signature: ()Z
*/
JNIEXPORT jboolean JNICALL Java_dc_jfilters_DC_1PipeOutStream_1t__1isEndOfStream
(JNIEnv *env, jobject thisJ) {
   DC_PipeOutStream_t *thisC = reinterpret_cast<DC_PipeOutStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   return static_cast<jboolean>(thisC->isEndOfWork());
}

/* 
* Class:     dc_jfilters_DC_0005fPipeOutStream_0005ft
* Method:    _write
* Signature: (Ldc/jfilters/DC_Buffer_t;)I
*/ 
JNIEXPORT jint JNICALL Java_dc_jfilters_DC_1PipeOutStream_1t__1write
(JNIEnv *env, jobject thisJ, jobject pbuff) {
   DC_PipeOutStream_t *thisC = reinterpret_cast<DC_PipeOutStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   DC_Buffer_t *pbuffC = reinterpret_cast<DC_Buffer_t *>(DC_JNIMap::GetJNIMap()->find(env, pbuff));
   
   return static_cast<jint>(thisC->write(pbuffC, NULL));
}

/* 
* Class:     dc_jfilters_DC_0005fPipeOutStream_0005ft
* Method:    _write_nocopy
* Signature: (Ldc/jfilters/DC_Buffer_t;)I
*/ 
JNIEXPORT jint JNICALL Java_dc_jfilters_DC_1PipeOutStream_1t__1write_1nocopy
(JNIEnv *env, jobject thisJ, jobject pbuff) {
   DC_PipeOutStream_t *thisC = reinterpret_cast<DC_PipeOutStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   DC_Buffer_t *pbuffC = reinterpret_cast<DC_Buffer_t *>(DC_JNIMap::GetJNIMap()->find(env, pbuff));
   
   return static_cast<jint>(thisC->write_nocopy(pbuffC, NULL));
}

/*
* Class:     dc_jfilters_DC_0005fPipeOutStream_0005ft
* Method:    _close
* Signature: (Z)I
*/
JNIEXPORT jint JNICALL Java_dc_jfilters_DC_1PipeOutStream_1t__1close
(JNIEnv *env , jobject thisJ, jboolean fEndOfWork) {
   DC_PipeOutStream_t *thisC = reinterpret_cast<DC_PipeOutStream_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   return static_cast<jint>(thisC->close(static_cast<bool>(fEndOfWork)));
}

