/* 
* This file provides the native implementation of the native methods defined 
* in DC_Work_t.java 
*/

#include <jni.h>
#include "dc_jfilters_DC_0005fWork_0005ft.h"
#include "util/dc_jnimap.h"
#include "reg/NativeReg.h"
#include "dc_work.h"

/*
* Class:     dc_jfilters_DC_0005fWork_0005ft
* Method:    _getWWorkNum
* Signature: ()I
*/
JNIEXPORT jint JNICALL Java_dc_jfilters_DC_1Work_1t__1getWWorkNum
(JNIEnv *env, jobject thisJ) {
   DC_Work_t *thisC = reinterpret_cast<DC_Work_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
 
   return static_cast<jint>(thisC->wWorkNum);
}

/*
* Class:     dc_jfilters_DC_0005fWork_0005ft
* Method:    _setWWorkNum
* Signature: (I)V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1Work_1t__1setWWorkNum
(JNIEnv *env, jobject thisJ, jint newWWorkNum) {
   DC_Work_t *thisC = reinterpret_cast<DC_Work_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

	cout << "The buffer in C++ work is " << thisC->buf.getMax() << endl;  
   thisC->wWorkNum = static_cast<int>(newWWorkNum);
	cout << "The buffer in C++ work is " << thisC->buf.getMax() << endl;

	cout << "The size of jint is " << sizeof(jint) << endl;
	cout << "The size of int is " << sizeof(thisC->wWorkNum) << endl;
}

/*
 * Class:     dc_jfilters_DC_0005fWork_0005ft
 * Method:    _getBuf
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1Work_1t__1getBuf
(JNIEnv *env, jobject thisJ) {
   DC_Work_t *thisC = reinterpret_cast<DC_Work_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

	cout << " The buffer in C++ work (getBuf) is " << thisC->buf.getMax() << endl;
   //create a reference between the java class and the C++ class
   jfieldID javaContainerID = env->GetFieldID(env->GetObjectClass(thisJ), "buf", "Ldc/jfilters/DC_Buffer_t;");
   if (javaContainerID) {
      jobject javaContainer = env->GetObjectField(thisJ, javaContainerID);
      if (javaContainer == NULL) {
	 cout << "The java class holder is null, creating a new skeleton in DC_Work->buf())" << endl;
         //tell the java class not to create a C++ class because it will be manually asigned
	 jvalue params[1];
	 params[0].z = false;

         if (NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_Buffer_t", "(Z)V", params, javaContainer)) {
	    env->SetObjectField(thisJ, javaContainerID, javaContainer);
         }
         else {
	    return;
         }
      }
      DC_JNIMap::GetJNIMap()->addPairNoOverwrite(env, javaContainer, reinterpret_cast<jlong>(&(thisC->buf)));
	cout << "Set up links, the buffer is of size " << thisC->buf.getMax() << endl;
	cout << "The pointer is recorded as " << reinterpret_cast<jlong>(&(thisC->buf)) << endl;
   }
}

/*
* Class:     dc_jfilters_DC_0005fWork_0005ft
* Method:    _setBuf
* Signature: (Ldc/jfilters/DC_Buffer_t;)V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1Work_1t__1setBuf
(JNIEnv *env , jobject thisJ, jobject newBuff) {
   DC_Work_t *thisC = reinterpret_cast<DC_Work_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   //store the c++ class reference in thisJ class buff
   thisC->buf = *(reinterpret_cast<DC_Buffer_t *>(DC_JNIMap::GetJNIMap()->find(env, newBuff)));
}

/*
* Class:     dc_jfilters_DC_0005fWork_0005ft
* Method:    _initialize
* Signature: ()J
*/
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1Work_1t__1initialize__
(JNIEnv *env, jobject thisJ) {
   DC_Work_t* newClass = new DC_Work_t();
   
   DC_JNIMap::GetJNIMap()->addPair(env, thisJ, reinterpret_cast<jlong>(newClass));
}

/*
* Class:     dc_jfilters_DC_0005fWork_0005ft
* Method:    _initialize
* Signature: (I)J
*/
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1Work_1t__1initialize__I
(JNIEnv *env, jobject thisJ, jint newBuffSize) {
   DC_Work_t* newClass = new DC_Work_t(newBuffSize);
   
   DC_JNIMap::GetJNIMap()->addPair(env, thisJ, reinterpret_cast<jlong>(newClass));
}

/*
* Class:     dc_jfilters_DC_0005fWork_0005ft
* Method:    _delete
* Signature: ()V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_DC_1Work_1t__1delete
(JNIEnv *env, jobject thisJ) {
   cerr << "Work remove" << endl;

   DC_JNIMap::GetJNIMap()->remove(env, thisJ);
}
