/*
* This file provides the native implementation of the native methods defined 
* in arg_t.java 
*/

#include <jni.h>
#include <string.h>
#include "dc_jfilters_arg_0005ft.h"
#include "util/dc_jnimap.h"
#include "reg/NativeReg.h"
#include "dc_filterservice.h"

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _getNins
* Signature: ()I
*/
JNIEXPORT jint JNICALL Java_dc_jfilters_arg_1t__1getNins
(JNIEnv *env, jobject thisJ) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   jint result = static_cast<jint>(thisC->nins);
   
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _setNins
* Signature: (I)V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1setNins
(JNIEnv *env, jobject thisJ, jint newNins) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   thisC->nins = static_cast<int>(newNins);
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _getIns
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1getIns__
(JNIEnv *env, jobject thisJ) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   //create references between the java array elements and the C++ elements
   if (thisC->ins != NULL) {
      jfieldID javaContainerID = env->GetFieldID(env->GetObjectClass(thisJ), "ins", "[Ldc/jfilters/DC_PipeInStream_t;");
      
      if (javaContainerID) {
         jobjectArray javaContainer = reinterpret_cast<jobjectArray>(env->GetObjectField(thisJ, javaContainerID));
         
         if (javaContainer == NULL || env->GetArrayLength(javaContainer) != thisC->nins) {
            javaContainer = env->NewObjectArray(static_cast<jint>(thisC->nins), env->FindClass("dc/jfilters/DC_PipeInStream_t"), NULL);
            env->SetObjectField(thisJ, javaContainerID, javaContainer);
         }
        
         for (int i = 0; i < thisC->nins; i++) {
            jobject curr = env->GetObjectArrayElement(javaContainer, i);

	    if (curr == NULL) {
         	NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_PipeInStream_t", "()V", NULL, curr);
		env->SetObjectArrayElement(javaContainer, i, curr);
	    }
            DC_JNIMap::GetJNIMap()->addPair(env, curr, reinterpret_cast<jlong>(&(thisC->ins[i])));
	    env->DeleteLocalRef(curr); 
         }
      }
   }
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _getIns
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1getIns__I
(JNIEnv *env, jobject thisJ, jint index) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   //create references between the java array elements and the C++ elements
   if (thisC->ins != NULL) {
      jfieldID javaContainerID = env->GetFieldID(env->GetObjectClass(thisJ), "ins", "[Ldc/jfilters/DC_PipeInStream_t;");
     
      if (javaContainerID) {
         jobjectArray javaContainer = reinterpret_cast<jobjectArray>(env->GetObjectField(thisJ, javaContainerID));
   
         if (javaContainer == NULL || env->GetArrayLength(javaContainer) != thisC->nins) {
            javaContainer= env->NewObjectArray(static_cast<jint>(thisC->nins), env->FindClass("dc/jfilters/DC_PipeInStream_t"), NULL);

            env->SetObjectField(thisJ, javaContainerID, javaContainer);
            DC_JNIMap::GetJNIMap()->remove(env, javaContainer);
         }
         jobject curr = env->GetObjectArrayElement(javaContainer, index);

         if (curr == NULL) {
            NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_PipeInStream_t", "()V", NULL, curr);
	    env->SetObjectArrayElement(javaContainer, index, curr);
	 }
	 DC_JNIMap::GetJNIMap()->addPair(env, curr, reinterpret_cast<jlong>(&(thisC->ins[static_cast<int>(index)])));
      } 
   } 
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _setIns
 * Signature: ([Ldc/jfilters/DC_PipeInStream_t;)V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1setIns___3Ldc_jfilters_DC_1PipeInStream_1t_2
(JNIEnv *env, jobject thisJ, jobjectArray newIns) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   if (thisC->ins != NULL) {
      delete[] thisC->ins;
   }
   thisC->ins = new DC_PipeInStream_t[env->GetArrayLength(newIns)];

   for (int i = 0; i < env->GetArrayLength(newIns); i++) {
      //create a link between each individual java class and C++ class
      jobject curr = env->GetObjectArrayElement(newIns, i);
      thisC->ins[i] = *(reinterpret_cast<DC_PipeInStream_t *>(DC_JNIMap::GetJNIMap()->find(env, curr)));
      env->DeleteLocalRef(curr);
   }
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _setIns
 * Signature: (Ldc/jfilters/DC_PipeInStream_t;I)V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1setIns__Ldc_jfilters_DC_1PipeInStream_1t_2I
(JNIEnv *env, jobject thisJ, jobject newIns, jint index) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   if (thisC->ins == NULL) {
      thisC->ins = new DC_PipeInStream_t[index + 1];
   }

   //create a link between the java class and the C++ class
   thisC->ins[index] = *(reinterpret_cast<DC_PipeInStream_t *>(DC_JNIMap::GetJNIMap()->find(env, newIns)));
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _getNouts
* Signature: ()I
*/
JNIEXPORT jint JNICALL Java_dc_jfilters_arg_1t__1getNouts
(JNIEnv *env, jobject thisJ) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   jint result = static_cast<jint>(thisC->nouts);
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _setNouts
* Signature: (I)V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1setNouts
(JNIEnv *env, jobject thisJ, jint newNouts) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   thisC->nouts = static_cast<int>(newNouts);
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _getOuts
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1getOuts__
(JNIEnv *env, jobject thisJ) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   //create references between the java array elements and the C++ elements
   if (thisC->outs != NULL) {
      jfieldID javaContainerID = env->GetFieldID(env->GetObjectClass(thisJ), "outs", "[Ldc/jfilters/DC_PipeOutStream_t;");
      
      if (javaContainerID) {
         jobjectArray javaContainer = reinterpret_cast<jobjectArray>(env->GetObjectField(thisJ, javaContainerID));
         
         if (javaContainer == NULL || env->GetArrayLength(javaContainer) != thisC->nouts) {
            javaContainer = env->NewObjectArray(static_cast<jint>(thisC->nouts), env->FindClass("dc/jfilters/DC_PipeOutStream_t"), NULL);
            env->SetObjectField(thisJ, javaContainerID, javaContainer);
         }
        
         for (int i = 0; i < thisC->nouts; i++) {
            jobject curr = env->GetObjectArrayElement(javaContainer, i);

            if (curr == NULL) {
                NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_PipeOutStream_t", "()V", NULL, curr);
		env->SetObjectArrayElement(javaContainer, i, curr);
	    }
            DC_JNIMap::GetJNIMap()->addPair(env, curr, reinterpret_cast<jlong>(&(thisC->outs[i])));
            env->DeleteLocalRef(curr); 
         }
      }
   }
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _getOuts
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1getOuts__I
(JNIEnv *env, jobject thisJ, jint index) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   //create references between the java array elements and the C++ elements
   if (thisC->outs != NULL) {
      jfieldID javaContainerID = env->GetFieldID(env->GetObjectClass(thisJ), "outs", "[Ldc/jfilters/DC_PipeOutStream_t;");
     
      if (javaContainerID) {
         jobjectArray javaContainer = reinterpret_cast<jobjectArray>(env->GetObjectField(thisJ, javaContainerID));

         if (javaContainer == NULL || env->GetArrayLength(javaContainer) != thisC->nouts) {
            javaContainer= env->NewObjectArray(static_cast<jint>(thisC->nouts), env->FindClass("dc/jfilters/DC_PipeOutStream_t"), NULL);
            env->SetObjectField(thisJ, javaContainerID, javaContainer);
            DC_JNIMap::GetJNIMap()->remove(env, javaContainer);
         }
         jobject curr = env->GetObjectArrayElement(javaContainer, index);

         if (curr == NULL) {
            NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_PipeOutStream_t", "()V", NULL, curr);
	    env->SetObjectArrayElement(javaContainer, index, curr);
	 }
         DC_JNIMap::GetJNIMap()->addPair(env, curr, reinterpret_cast<jlong>(&(thisC->outs[static_cast<int>(index)])));
      } 
   } 
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _setOuts
 * Signature: ([Ldc/jfilters/DC_PipeOutStream_t;)V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1setOuts___3Ldc_jfilters_DC_1PipeOutStream_1t_2
(JNIEnv *env, jobject thisJ, jobjectArray newOuts) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   if (thisC->outs != NULL) {
      delete[] thisC->outs;
   }
   thisC->outs = new DC_PipeOutStream_t[env->GetArrayLength(newOuts)];

   for (int i = 0; i < env->GetArrayLength(newOuts); i++) {
      //create a link between each individual java class and C++ class
      jobject curr = env->GetObjectArrayElement(newOuts, i);
      thisC->outs[i] = *(reinterpret_cast<DC_PipeOutStream_t *>(DC_JNIMap::GetJNIMap()->find(env, curr)));
      env->DeleteLocalRef(curr);
   }
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _setOuts
 * Signature: (Ldc/jfilters/DC_PipeOutStream_t;I)V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1setOuts__Ldc_jfilters_DC_1PipeOutStream_1t_2I
(JNIEnv *env, jobject thisJ, jobject newOuts, jint index) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   if (thisC->outs == NULL) {
      thisC->outs = new DC_PipeOutStream_t[index + 1];
   }

   //create a link between the java class and the C++ class
   thisC->outs[index] = *(reinterpret_cast<DC_PipeOutStream_t *>(DC_JNIMap::GetJNIMap()->find(env, newOuts)));
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _getSbFilterName
 * Signature: ()Ljava/lang/String; 
 */
JNIEXPORT jstring JNICALL Java_dc_jfilters_arg_1t__1getSbFilterName 
(JNIEnv *env, jobject thisJ) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   jstring result = env->NewStringUTF(const_cast<const char *>(thisC->sbFilterName));
   
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _setSbFilterName
* Signature: (Ljava/lang/String;)V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1setSbFilterName
(JNIEnv *env, jobject thisJ, jstring newSbFilterName) {
   jboolean isCopy;
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   const char *newSbFilterNameC = env->GetStringUTFChars(newSbFilterName, &isCopy);
   
   if (thisC->sbFilterName != NULL) {
      delete[] thisC->sbFilterName;
   }
   thisC->sbFilterName = new char[env->GetStringUTFLength(newSbFilterName) + 1];
   thisC->sbFilterName = newSbFilterNameC;
   
   if (isCopy == JNI_TRUE) {
      env->ReleaseStringUTFChars(newSbFilterName, newSbFilterNameC);
   }
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _setPWork
* Signature: (Ldc/jfilters/DC_Work_t;)V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1setPWork
(JNIEnv *env, jobject thisJ, jobject newPWork) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   //store the c++ class reference in this class nins
   thisC->pwork = reinterpret_cast<DC_Work_t *>(DC_JNIMap::GetJNIMap()->find(env, newPWork));
}

/*
 * Class:     dc_jfilters_arg_0005ft
 * Method:    _getPWork
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1getPWork
(JNIEnv *env, jobject thisJ) {
  DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));

   //create a reference between the java class and the C++ class
   if (thisC->pwork != NULL) {

      jfieldID javaContainerID = env->GetFieldID(env->GetObjectClass(thisJ), "pWork", "Ldc/jfilters/DC_Work_t;");
 
      if (javaContainerID) {
         jobject javaContainer = env->GetObjectField(thisJ, javaContainerID);
         if (javaContainer == NULL) {
            if (NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_Work_t", "()V", NULL, javaContainer)) {
               env->SetObjectField(thisJ, javaContainerID, javaContainer);
            }
	    else {
		return;
	    }
         }
         DC_JNIMap::GetJNIMap()->addPair(env, javaContainer, reinterpret_cast<jlong>(thisC->pwork));
      }
   }
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _initialize
* Signature: ()J
*/
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1initialize
(JNIEnv *env, jobject thisJ) {
   DC_Filter_Base_t::arg_t* newClass = new DC_Filter_Base_t::arg_t();
   
   DC_JNIMap::GetJNIMap()->addPair(env, thisJ, reinterpret_cast<jlong>(newClass));
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _delete
* Signature: ()V
*/
JNIEXPORT void JNICALL Java_dc_jfilters_arg_1t__1delete
(JNIEnv *env, jobject thisJ) {
   DC_JNIMap::GetJNIMap()->remove(env, thisJ);
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _insIndex
* Signature: (Ljava/lang/String;)I
*/
JNIEXPORT jint JNICALL Java_dc_jfilters_arg_1t__1insIndex
(JNIEnv *env, jobject thisJ, jstring sbName) {
   jboolean isCopy;
   
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   const char *sbNameC = env->GetStringUTFChars(sbName, &isCopy);
   
   jint result = static_cast<jint>(thisC->insIndex(const_cast<char *>(sbNameC)));
   
   if (isCopy == JNI_TRUE) {
      env->ReleaseStringUTFChars(sbName, sbNameC);
   }
   
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _outsIndex
* Signature: (Ljava/lang/String;)I
*/
JNIEXPORT jint JNICALL Java_dc_jfilters_arg_1t__1outsIndex
(JNIEnv *env, jobject thisJ, jstring sbName) {
   jboolean isCopy;
   
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   const char *sbNameC = env->GetStringUTFChars(sbName, &isCopy);
   
   jint result = static_cast<jint>(thisC->outsIndex(const_cast<char *>(sbNameC)));
   
   if (isCopy == JNI_TRUE) {
      env->ReleaseStringUTFChars(sbName, sbNameC);
   }
   
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _insLookup
* Signature: (Ljava/lang/String;)Ldc/jfilters/DC_PipeInStream_t;
*/
JNIEXPORT jobject JNICALL Java_dc_jfilters_arg_1t__1insLookup
(JNIEnv *env, jobject thisJ, jstring sbName) {
   jboolean isCopy;
   
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   const char *sbNameC = env->GetStringUTFChars(sbName, &isCopy);
   
   DC_PipeInStream_t *resultC = thisC->insLookup(const_cast<char *>(sbNameC));
   jobject result = NULL;
   
   if (isCopy == JNI_TRUE) {
      env->ReleaseStringUTFChars(sbName, sbNameC);
   }
   
   //return object from insLookup or NULL
   if (resultC != NULL) { 
      //construct a new DC_PipeInStream_t in java with return val as the native reference
      if (NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_PipeInStream", "()V", NULL, result) == 1) {
         DC_JNIMap::GetJNIMap()->addPair(env, result, reinterpret_cast<jlong>(resultC));
      }
   }
   
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _outsLookup
* Signature: (Ljava/lang/String;)Ldc/jfilters/DC_PipeOutStream_t;
*/
JNIEXPORT jobject JNICALL Java_dc_jfilters_arg_1t__1outsLookup
(JNIEnv *env, jobject thisJ, jstring sbName) {
   jboolean isCopy;
   
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   const char *sbNameC = env->GetStringUTFChars(sbName, &isCopy);
   
   DC_PipeInStream_t *resultC = thisC->insLookup(const_cast<char *>(sbNameC));
   jobject result = NULL;
   
   if (isCopy == JNI_TRUE) {
      env->ReleaseStringUTFChars(sbName, sbNameC);
   }
   
   //return the result from outsLookup or NULL
   if (resultC != NULL) {
      //construct a new DC_PipeOutStream_t in java with return val as the native reference
      if (NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_PipeOutStream_t", "()V", NULL, result) == 1) {
         DC_JNIMap::GetJNIMap()->addPair(env, result, reinterpret_cast<jlong>(resultC));
      }
   }
   
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _insReadAny
* Signature: (Ldc/jfilters/DC_ObjectWrapper;[Z)Ldc/jfilters/DC_Buffer_t;
*/
JNIEXPORT jobject JNICALL Java_dc_jfilters_arg_1t__1insReadAny
(JNIEnv *env, jobject thisJ, jobject piFound, jbooleanArray rgStreamSet) {
   jboolean isCopy;
   
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   //if the piFound parameter is not NULL, allow the insReadAny function to set its value, otherwise, leave it as NULL to be ignored
   int* piFoundC = NULL;
   if (piFound != NULL) {
      piFoundC = new int;
   }
   
   //convert jboolean array to bool array 
   //(bool and jbooleans are usually different size so for platform comatibilty, go through each element of the array individually)
   bool *rgStreamSetC = new bool[env->GetArrayLength(rgStreamSet)];
   jboolean *rgStreamSetJBoolean = env->GetBooleanArrayElements(rgStreamSet, &isCopy);
   for (int i = 0; i < env->GetArrayLength(rgStreamSet); i++) {
      rgStreamSetC[i] = static_cast<bool>(rgStreamSetJBoolean[i]);
   }
   
   DC_Buffer_t *resultC = thisC->insReadAny(piFoundC, rgStreamSetC);
   
   //construct a new DC_Buffer_t in java with return val as the native reference
   jobject result = NULL;

   if (NativeReg::ConstructNReg()->CreateJavaClass(env, "dc/jfilters/DC_Buffer_t", "(Z)V", NULL, result) == 1) {
      DC_JNIMap::GetJNIMap()->addPair(env, result, reinterpret_cast<jlong>(resultC));
   }
   
   
   if (piFoundC != NULL) {
      //create a java.lang.Integer object to hold the result of pFoundC
      jvalue params[1];
      params[0].j = static_cast<jint>((*piFoundC));
      jobject Integer;

      if (NativeReg::ConstructNReg()->CreateJavaClass(env, "java.lang.Integer", "(I)V", params, Integer) == 1) {
      
         //save the value of piFoundC so it can be accessed in Java
         jclass DC_ObjectWrapperClass = env->GetObjectClass(piFound);
         jmethodID DC_ObjectWrapperSet = env->GetMethodID(DC_ObjectWrapperClass, "setVal", "(Ljava.lang.Object;)V");
         env->CallVoidMethod(piFound, DC_ObjectWrapperSet, Integer);
      }
   }
   
   //cleanup and temporary memory used
   //release array and ignore any changes made by the C++ function
   if (isCopy == JNI_TRUE) {
      env->ReleaseBooleanArrayElements(rgStreamSet, rgStreamSetJBoolean, JNI_ABORT);
   }
   delete piFound;
   delete[] rgStreamSetC;
   
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _insNumEOW
* Signature: ()I
*/
JNIEXPORT jint JNICALL Java_dc_jfilters_arg_1t__1insNumEOW
(JNIEnv *env, jobject thisJ) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));;
   
   jint result = static_cast<jint>(thisC->insNumEOW());
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _insAllEOW
* Signature: ()Z
*/
JNIEXPORT jboolean JNICALL Java_dc_jfilters_arg_1t__1insAllEOW
(JNIEnv *env, jobject thisJ) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));;
   
   jboolean result = static_cast<jboolean>(thisC->insAllEOW());
   return result;
}

/*
* Class:     dc_jfilters_arg_0005ft
* Method:    _closeOutputWaitInput
* Signature: (IZ)I
*/
JNIEXPORT jint JNICALL Java_dc_jfilters_arg_1t__1closeOutputWaitInput
(JNIEnv *env, jobject thisJ, jint wWorkNum, jboolean fEndOfWork) {
   DC_Filter_Base_t::arg_t *thisC = reinterpret_cast<DC_Filter_Base_t::arg_t *>(DC_JNIMap::GetJNIMap()->find(env, thisJ));
   
   jint result = static_cast<jint>(thisC->CloseOutputWaitInput(wWorkNum, fEndOfWork));
   return result;
}
