/*
 * This function registers the JNI methods with the Java Virtual Machine
 */

#include <iostream.h>
#include "dc_register_methods.h"
#include "dc_jfilters_arg_0005ft.h"
#include "dc_jfilters_DC_0005fBuffer_0005ft.h"
#include "dc_jfilters_DC_0005fFilter_0005fBase_0005ft.h"
#include "dc_jfilters_DC_0005fPipeInStream_0005ft.h"
#include "dc_jfilters_DC_0005fPipeOutStream_0005ft.h"
#include "dc_jfilters_DC_0005fWork_0005ft.h"
#include "dc_jfilters_initarg_0005ft.h"

bool DC_RegisterMethods::alreadyRegistered = false;
DC_Mutex DC_RegisterMethods::lock = DC_Mutex();

void DC_RegisterMethods::registerMethods() {
   lock.lock();

   cout << "Registering methods is set to: " << alreadyRegistered << endl;
   if (DC_RegisterMethods::alreadyRegistered == false) {
     DC_RegisterMethods::alreadyRegistered = true;
     cout << "Registering methods" << endl;
     NativeReg *reg = NativeReg::ConstructNReg();

     //REGISTER dc.jfilter.arg_t METHODS
     registerArgTMethods(reg);
     //REGISTER dc.jfilter.DC_Buffer_t METHODS
     registerBufferTMethods(reg);
     //REGISTER dc.jfilter.DC_Filter_Base_t METHODS
     registerFilterBaseMethods(reg);
     //REGISTER dc.jfilter.DC_PipeInStream_t METHODS'
     registerPipeInStreamMethods(reg);
     //REGISTER dc.jfilter.DC_PipeOutStream_t METHODS
     registerPipeOutStreamMethods(reg);
     //REGISTER dc.jfilter.DC_Work_t METHODS
     registerWorkMethods(reg);
     //REGISTER dc.jfilter.initarg_t METHODS
     registerInitArgMethods(reg);

     cout << "Finished registering " << reg->GetNativeCount() << " methods" << endl;
   }
   lock.unlock();
}

void DC_RegisterMethods::registerArgTMethods(NativeReg *reg) {
   reg->RegisterMethod("dc/jfilters/arg_t", "_getNins", "()I", (void *) Java_dc_jfilters_arg_1t__1getNins);
   reg->RegisterMethod("dc/jfilters/arg_t", "_setNins", "(I)V", (void *) Java_dc_jfilters_arg_1t__1setNins);
   reg->RegisterMethod("dc/jfilters/arg_t", "_getIns", "()V", (void *) Java_dc_jfilters_arg_1t__1getIns__);
   reg->RegisterMethod("dc/jfilters/arg_t", "_getIns", "(I)V", (void *) Java_dc_jfilters_arg_1t__1getIns__I);
   reg->RegisterMethod("dc/jfilters/arg_t", "_setIns", "([Ldc/jfilters/DC_PipeInStream_t;)V", (void *) Java_dc_jfilters_arg_1t__1setIns___3Ldc_jfilters_DC_1PipeInStream_1t_2);
   reg->RegisterMethod("dc/jfilters/arg_t", "_setIns", "(Ldc/jfilters/DC_PipeInStream_t;I)V", (void *) Java_dc_jfilters_arg_1t__1setIns__Ldc_jfilters_DC_1PipeInStream_1t_2I);
   reg->RegisterMethod("dc/jfilters/arg_t", "_getNouts", "()I", (void *) Java_dc_jfilters_arg_1t__1getNouts);
   reg->RegisterMethod("dc/jfilters/arg_t", "_setNouts", "(I)V", (void *) Java_dc_jfilters_arg_1t__1setNouts);
   reg->RegisterMethod("dc/jfilters/arg_t", "_getOuts", "()V", (void *) Java_dc_jfilters_arg_1t__1getOuts__);
   reg->RegisterMethod("dc/jfilters/arg_t", "_getOuts", "(I)V", (void *) Java_dc_jfilters_arg_1t__1getOuts__I);
   reg->RegisterMethod("dc/jfilters/arg_t", "_setOuts", "([Ldc/jfilters/DC_PipeOutStream_t;)V", (void *) Java_dc_jfilters_arg_1t__1setOuts___3Ldc_jfilters_DC_1PipeOutStream_1t_2);
   reg->RegisterMethod("dc/jfilters/arg_t", "_setOuts", "(Ldc/jfilters/DC_PipeOutStream_t;I)V", (void *) Java_dc_jfilters_arg_1t__1setOuts__Ldc_jfilters_DC_1PipeOutStream_1t_2I);
   reg->RegisterMethod("dc/jfilters/arg_t", "_getSbFilterName", "()Ljava/lang/String;", (void *) Java_dc_jfilters_arg_1t__1getSbFilterName);
   reg->RegisterMethod("dc/jfilters/arg_t", "_setSbFilterName", "(Ljava/lang/String;)V", (void *) Java_dc_jfilters_arg_1t__1setSbFilterName);
   reg->RegisterMethod("dc/jfilters/arg_t", "_setPWork", "(Ldc/jfilters/DC_Work_t;)V", (void *) Java_dc_jfilters_arg_1t__1setPWork);
   reg->RegisterMethod("dc/jfilters/arg_t", "_getPWork", "()V", (void *) Java_dc_jfilters_arg_1t__1getPWork);
   reg->RegisterMethod("dc/jfilters/arg_t", "_initialize", "()V", (void *) Java_dc_jfilters_arg_1t__1initialize);
   reg->RegisterMethod("dc/jfilters/arg_t", "_delete", "()V", (void *) Java_dc_jfilters_arg_1t__1delete);
   reg->RegisterMethod("dc/jfilters/arg_t", "_insIndex", "(Ljava/lang/String;)I", (void *) Java_dc_jfilters_arg_1t__1insIndex);
   reg->RegisterMethod("dc/jfilters/arg_t", "_outsIndex", "(Ljava/lang/String;)I", (void *) Java_dc_jfilters_arg_1t__1outsIndex);
   reg->RegisterMethod("dc/jfilters/arg_t", "_insLookup", "(Ljava/lang/String;)Ldc/jfilters/DC_PipeInStream_t;", (void *) Java_dc_jfilters_arg_1t__1insLookup);
   reg->RegisterMethod("dc/jfilters/arg_t", "_outsLookup", "(Ljava/lang/String;)Ldc/jfilters/DC_PipeOutStream_t;", (void *) Java_dc_jfilters_arg_1t__1outsLookup);
   reg->RegisterMethod("dc/jfilters/arg_t", "_insReadAny", "(Ldc/jfilters/DC_ObjectWrapper;[Z)Ldc/jfilters/DC_Buffer_t;", (void *) Java_dc_jfilters_arg_1t__1insReadAny);
   reg->RegisterMethod("dc/jfilters/arg_t", "_insNumEOW", "()I", (void *) Java_dc_jfilters_arg_1t__1insNumEOW);
   reg->RegisterMethod("dc/jfilters/arg_t", "_insAllEOW", "()Z", (void *) Java_dc_jfilters_arg_1t__1insAllEOW);
   reg->RegisterMethod("dc/jfilters/arg_t", "_closeOutputWaitInput", "(IZ)I", (void *) Java_dc_jfilters_arg_1t__1closeOutputWaitInput);
}

void DC_RegisterMethods::registerBufferTMethods(NativeReg *reg) {
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_new", "(J)[B", (void *) Java_dc_jfilters_DC_1Buffer_1t__1new);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_delete_funct", "()V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1delete_1funct);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_set", "([BII)V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1set);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_empty", "()V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1empty);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_getMax", "()J", (void *) Java_dc_jfilters_DC_1Buffer_1t__1getMax);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_getBuffer", "()[B", (void *) Java_dc_jfilters_DC_1Buffer_1t__1getBuffer);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_getSize", "()J", (void *) Java_dc_jfilters_DC_1Buffer_1t__1getSize);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_getFree", "()J", (void *) Java_dc_jfilters_DC_1Buffer_1t__1getFree);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_getFreeBuffer", "()[B", (void *) Java_dc_jfilters_DC_1Buffer_1t__1getFreeBuffer);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_getExtractBuffer", "()[B", (void *) Java_dc_jfilters_DC_1Buffer_1t__1getExtractBuffer);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_getSizeExtract", "()J", (void *) Java_dc_jfilters_DC_1Buffer_1t__1getSizeExtract);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_resetExtract", "(J)J", (void *) Java_dc_jfilters_DC_1Buffer_1t__1resetExtract);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_append", "([BJ)[B", (void *) Java_dc_jfilters_DC_1Buffer_1t__1append);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_extract", "([BJ)I", (void *) Java_dc_jfilters_DC_1Buffer_1t__1extract);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_setSize", "(J)I", (void *) Java_dc_jfilters_DC_1Buffer_1t__1setSize);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_getPNext", "()Ldc/jfilters/DC_Buffer_t;", (void *) Java_dc_jfilters_DC_1Buffer_1t__1getPNext);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_setPNext", "(Ldc/jfilters/DC_Buffer_t;)V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1setPNext);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_initialize", "()V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1initialize__);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_initialize", "(I)V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1initialize__I);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_clone", "(Ldc/jfilters/DC_Buffer_t;)V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1clone);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_delete", "()V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1delete);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_consume", "()V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1consume);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_getConsume", "()Z", (void *) Java_dc_jfilters_DC_1Buffer_1t__1getConsume);
   reg->RegisterMethod("dc/jfilters/DC_Buffer_t", "_setConsume", "(Z)V", (void *) Java_dc_jfilters_DC_1Buffer_1t__1setConsume);
}

void DC_RegisterMethods::registerFilterBaseMethods(NativeReg *reg) {
   reg->RegisterMethod("dc/jfilters/DC_Filter_Base_t", "_getSbFilterName", "()Ljava/lang/String;", (void *) Java_dc_jfilters_DC_1Filter_1Base_1t__1getSbFilterName);
   reg->RegisterMethod("dc/jfilters/DC_Filter_Base_t", "_setSbFilterName", "(Ljava/lang/String;)V", (void *) Java_dc_jfilters_DC_1Filter_1Base_1t__1setSbFilterName);
   reg->RegisterMethod("dc/jfilters/DC_Filter_Base_t", "_findAppFilterConfig", "(Ljava/lang/String;I)Ljava/lang/String;", (void *) Java_dc_jfilters_DC_1Filter_1Base_1t__1findAppFilterConfig);
   reg->RegisterMethod("dc/jfilters/DC_Filter_Base_t", "_findAppFilterConfigInt", "(Ljava/lang/String;IZ)J", (void *) Java_dc_jfilters_DC_1Filter_1Base_1t__1findAppFilterConfigInt);
   reg->RegisterMethod("dc/jfilters/DC_Filter_Base_t", "_findAppFilterConfigDbl", "(Ljava/lang/String;I)D", (void *) Java_dc_jfilters_DC_1Filter_1Base_1t__1findAppFilterConfigDbl);
   reg->RegisterMethod("dc/jfilters/DC_Filter_Base_t", "_filterLock", "()V", (void *) Java_dc_jfilters_DC_1Filter_1Base_1t__1filterLock);
   reg->RegisterMethod("dc/jfilters/DC_Filter_Base_t", "_filterUnlock", "()V", (void *) Java_dc_jfilters_DC_1Filter_1Base_1t__1filterUnlock);
}

void DC_RegisterMethods::registerPipeInStreamMethods(NativeReg *reg) {
   reg->RegisterMethod("dc/jfilters/DC_PipeInStream_t", "_initialize", "()V", (void *) Java_dc_jfilters_DC_1PipeInStream_1t__1initialize);
   reg->RegisterMethod("dc/jfilters/DC_PipeInStream_t", "_delete", "()V", (void *) Java_dc_jfilters_DC_1PipeInStream_1t__1delete);
   reg->RegisterMethod("dc/jfilters/DC_PipeInStream_t", "_getName", "()Ljava/lang/String;", (void *) Java_dc_jfilters_DC_1PipeInStream_1t__1getName);
   reg->RegisterMethod("dc/jfilters/DC_PipeInStream_t", "_isEndOfWork", "()Z", (void *) Java_dc_jfilters_DC_1PipeInStream_1t__1isEndOfWork);
   reg->RegisterMethod("dc/jfilters/DC_PipeInStream_t", "_isEndOfStream", "()Z", (void *) Java_dc_jfilters_DC_1PipeInStream_1t__1isEndOfStream);
   reg->RegisterMethod("dc/jfilters/DC_PipeInStream_t", "_read", "()Ldc/jfilters/DC_Buffer_t;", (void *) Java_dc_jfilters_DC_1PipeInStream_1t__1read);
   reg->RegisterMethod("dc/jfilters/DC_PipeInStream_t", "_close", "()I", (void *) Java_dc_jfilters_DC_1PipeInStream_1t__1close);
}

void DC_RegisterMethods::registerPipeOutStreamMethods(NativeReg *reg) {
   reg->RegisterMethod("dc/jfilters/DC_PipeOutStream_t", "_initialize", "()V", (void *) Java_dc_jfilters_DC_1PipeOutStream_1t__1initialize);
   reg->RegisterMethod("dc/jfilters/DC_PipeOutStream_t", "_delete", "()V", (void *) Java_dc_jfilters_DC_1PipeOutStream_1t__1delete);
   reg->RegisterMethod("dc/jfilters/DC_PipeOutStream_t", "_getName", "()Ljava/lang/String;", (void *) Java_dc_jfilters_DC_1PipeOutStream_1t__1getName);
   reg->RegisterMethod("dc/jfilters/DC_PipeOutStream_t", "_isEndOfWork", "()Z", (void *) Java_dc_jfilters_DC_1PipeOutStream_1t__1isEndOfWork);
   reg->RegisterMethod("dc/jfilters/DC_PipeOutStream_t", "_isEndOfStream", "()Z", (void *) Java_dc_jfilters_DC_1PipeOutStream_1t__1isEndOfStream);
   reg->RegisterMethod("dc/jfilters/DC_PipeOutStream_t", "_write", "(Ldc/jfilters/DC_Buffer_t;)I", (void *) Java_dc_jfilters_DC_1PipeOutStream_1t__1write);
   reg->RegisterMethod("dc/jfilters/DC_PipeOutStream_t", "_write_nocopy", "(Ldc/jfilters/DC_Buffer_t;)I", (void *) Java_dc_jfilters_DC_1PipeOutStream_1t__1write_1nocopy);
   reg->RegisterMethod("dc/jfilters/DC_PipeOutStream_t", "_close", "(Z)I", (void *) Java_dc_jfilters_DC_1PipeOutStream_1t__1close);
}

void DC_RegisterMethods::registerWorkMethods(NativeReg *reg) {
   reg->RegisterMethod("dc/jfilters/DC_Work_t", "_getWWorkNum", "()I", (void *) Java_dc_jfilters_DC_1Work_1t__1getWWorkNum);
   reg->RegisterMethod("dc/jfilters/DC_Work_t", "_setWWorkNum", "(I)V", (void *) Java_dc_jfilters_DC_1Work_1t__1setWWorkNum);
   reg->RegisterMethod("dc/jfilters/DC_Work_t", "_getBuf", "()V", (void *) Java_dc_jfilters_DC_1Work_1t__1getBuf);
   reg->RegisterMethod("dc/jfilters/DC_Work_t", "_setBuf", "(Ldc/jfilters/DC_Buffer_t;)V", (void *) Java_dc_jfilters_DC_1Work_1t__1setBuf);
   reg->RegisterMethod("dc/jfilters/DC_Work_t", "_initialize", "()V", (void *) Java_dc_jfilters_DC_1Work_1t__1initialize__);
   reg->RegisterMethod("dc/jfilters/DC_Work_t", "_initialize", "(I)V", (void *) Java_dc_jfilters_DC_1Work_1t__1initialize__I);
   reg->RegisterMethod("dc/jfilters/DC_Work_t", "_delete", "()V", (void *) Java_dc_jfilters_DC_1Work_1t__1delete);
}

void DC_RegisterMethods::registerInitArgMethods(NativeReg *reg) {
   reg->RegisterMethod("dc/jfilters/initarg_t", "_getArgc", "()I", (void *) Java_dc_jfilters_initarg_1t__1getArgc);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_setArgc", "(I)V", (void *) Java_dc_jfilters_initarg_1t__1setArgc);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_getArgv", "()[Ljava/lang/String;", (void *) Java_dc_jfilters_initarg_1t__1getArgv__);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_getArgv", "(I)Ljava/lang/String;", (void *) Java_dc_jfilters_initarg_1t__1getArgv__I);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_setArgv", "([Ljava/lang/String;)V", (void *) Java_dc_jfilters_initarg_1t__1setArgv___3Ljava_lang_String_2);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_setArgv", "(Ljava/lang/String;I)V", (void *) Java_dc_jfilters_initarg_1t__1setArgv__Ljava_lang_String_2I);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_getSbFilterName", "()Ljava/lang/String;", (void *) Java_dc_jfilters_initarg_1t__1getSbFilterName);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_setSbFilterName", "(Ljava/lang/String;)V", (void *) Java_dc_jfilters_initarg_1t__1setSbFilterName);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_getPWork", "()V", (void *) Java_dc_jfilters_initarg_1t__1getPWork);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_setPWork", "(Ldc/jfilters/DC_Work_t;)V", (void *) Java_dc_jfilters_initarg_1t__1setPWork);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_initialize", "()V", (void *) Java_dc_jfilters_initarg_1t__1initialize);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_delete", "()V", (void *) Java_dc_jfilters_initarg_1t__1delete);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_maxCopySets", "()I", (void *) Java_dc_jfilters_initarg_1t__1maxCopySets);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_rankCopySets", "()I", (void *) Java_dc_jfilters_initarg_1t__1rankCopySets);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_maxCopies", "()I", (void *) Java_dc_jfilters_initarg_1t__1maxCopies);
   reg->RegisterMethod("dc/jfilters/initarg_t", "_rankCopies", "()I", (void *) Java_dc_jfilters_initarg_1t__1rankCopies);
}
