// -*- c++ -*-
// ****************************************************************************
//  Name: dc_barrier.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 09/11/1999 : mdb - Created.
//        10/23/1999 : mdb - Changes for DCE use.
//        08/13/2000 : mdb - Added correct resetting for repeated use.
//  Desc: Resuable thread barrier implementation.
//  Note: There is no pthread_cleanup code for when a thread is cancelled
//        holding a barrier lock.
// ****************************************************************************
/** @file dc_barrier.h */

#if !defined(H_DC_BARRIER)
#define H_DC_BARRIER

#include "dc_mutex.h"
#include "dc_cond.h"

/// Resuable thread barrier implementation.
class DC_Barrier {
private:
  int  x;
  int  n;

  DC_Mutex mutex;
  DC_Cond  cv;

  void _init(void);

public:
  DC_Barrier(void);
  DC_Barrier(int num);

  void set(int num);
  void sync(bool fSlowWakeup=false);
};


#endif /* H_DC_BARRIER */
// ****************************************************************************
