// -*- c++ -*-
// ****************************************************************************
//  Name: dc_cond.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 11/20/2000 : mdb - Created.
//  Desc: Simple synchronization wrappers.
// ****************************************************************************
/** @file dc_cond.h */

#if !defined(H_DC_COND)
#define H_DC_COND

#include "../common-config.h"

#include <pthread.h>
#include <time.h>  /* for struct timespec */

#include "dc_mutex.h"

/// Simple synchronization wrapper.
class DC_Cond {
private:
  pthread_cond_t cv;

public:
  DC_Cond(pthread_condattr_t *pattr=NULL);
  ~DC_Cond(void);

  void signal(void);
  void broadcast(void);

  void wait(DC_Mutex &mutex);
  void wait(DC_Mutex *pmutex) { wait(*pmutex); };

  bool wait(DC_Mutex &mutex, const struct timespec *abstime);
  bool wait(DC_Mutex *pmutex, const struct timespec *abstime) {
    return wait(*pmutex, abstime);
  };
};


#endif /* H_DC_COND */
// ****************************************************************************
