// -*- c++ -*-
// ****************************************************************************
//  Name: dc_libary.h
//  Athr: Mike Gray (mgray)
//  Date: 05/20/2002 : mgray - Created.
//  Desc: Supporting dynamic library functionality
// ****************************************************************************
/** @file dc_library.h */

#if !defined(H_DC_LIBRARY)
#define H_DC_LIBRARY

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

/// Supporting dynamic library functionality.
class Library {
private:
  char *filename;
  void *libHandle;
  bool loaded;
public:
  Library(void);
  Library(char *libname_in);
  ~Library(void);
public:
  char *set(char *libname_in);

  /* returns 0 on success, -1 otherwise */
  int load(void);

  void unload(void);

  const char *getErrorMsg(void);

  /* returns NULL on error */
  void *getFunction(char *functionName);
};


#endif /* H_DC_LIBRARY */
// ****************************************************************************

