// -*- c++ -*-
// ****************************************************************************
//  Name: dc_mutex.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 11/20/2000 : mdb - Created.
//  Desc: Simple synchronization wrappers.
// ****************************************************************************
/** @file dc_mutex.h */

#if !defined(H_DC_MUTEX)
#define H_DC_MUTEX

#include "../common-config.h"

#include <pthread.h>

// define this to enable additional runtime error checking and reporting
// Note: this is broken, and should not be used.
//#define DCDBG_USE_MUTEX_CHECKS

/// Simple synchronization wrappers.
class DC_Mutex {
private:
  pthread_mutex_t mutex;
#if defined(DCDBG_USE_MUTEX_CHECKS)
  // for a debugging mutex, we provide the lock via a bool
  pthread_mutex_t mutexDebug;
  pthread_cond_t  cvDebug;
  char     *sbName;
  bool      fLocked;
  pthread_t tidOwner;
#endif /* DCDBG_USE_MUTEX_CHECKS */

public:
  DC_Mutex(char *sbName=NULL, pthread_mutexattr_t *pattr=NULL);
  ~DC_Mutex(void);

  void lock(void);
  void unlock(void);

  // return T if it was locked
  bool trylock(void);

#if defined(DCDBG_USE_MUTEX_CHECKS)
  void implicitUnlock(void);  // called by cond before cv wait
  void implicitLock(void);    // called by cond after cv wait
#endif /* DCDBG_USE_MUTEX_CHECKS */

  pthread_mutex_t &getNative(void) { return mutex; };
};


#endif /* H_DC_MUTEX */
// ****************************************************************************
