// -*- c++ -*-
// ****************************************************************************
//  Name: dc_namevalue.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 03/11/1998 : mdb - Created.
//  Desc: Simple name/value pair storage.
// ****************************************************************************
/** @file dc_namevalue.h */

#if !defined(H_NAMEVALUE)
#define H_NAMEVALUE

#include "dc_standard.h"
#include "dc_darray.h"


typedef struct NameValue_Entry_s {
  char *sbName;
  char *sbValue;
} NameValue_Entry_t;


/// Simple name/value pair storage.
class NameValue {
protected:
  DArray<NameValue_Entry_t> rgEntry;
  bool fFlush;

  int iEntry;  // iterator

public:
  NameValue(void) { fFlush = false; };
  ~NameValue(void) { if (fFlush) Flush(); };

  int Add(char *sbName, char *sbValue);
  int AddReplace(char *sbName, char *sbValue);
  int Index(char *sbName, Types::uint &i);
  char *Find(char *sbName);

  Types::uint Num(void) { return rgEntry.NumElem(); };
  Types::uint NumElem(void) { return rgEntry.NumElem(); };

  void Flush(void);

  // iterator
  char *FirstName(void);
  char *NextName(void);
  char *CurrentValue(void);

  friend ostream &operator<<(ostream &os, NameValue &nv);
};


#endif /* H_NAMEVALUE */
// ****************************************************************************
