// -*- c++ -*-
// ****************************************************************************
//  Name: dc_regex.h
//  Athr: Michael D. Beynon (mdb)
//  Date: 05/07/2001 : mdb - Created.
//  Desc: Simple regex class.
// ****************************************************************************
/** @file dc_regex.h */

#if !defined(H_DC_REGEX)
#define H_DC_REGEX

#include "../common-config.h"

#include <regex.h>

/// Simple regex class.
class DC_Regex {
private:
  char *sbPattern;
  regex_t re;

public:
  DC_Regex(void);
  ~DC_Regex(void);

  // Compile the extended regex pattern
  // Note: we also support "*" as an alias for ".*"
  // rtn: 0 == ok, else error
  int setPattern(const char *sbPattern);
  const char *getPattern(void) { return sbPattern; };

  // Check if string matches the pattern
  // fNoSub - t==whole string must match
  // rtn: t==match, f==no match
  bool match(const char *sb, bool fNoSub=true);
};

#endif /* H_DC_REGEX */
// ****************************************************************************
