// ****************************************************************************
//  Name: dc_template-instantiation.cpp
//  Athr: Michael D. Beynon (mdb)
//  Date: 04/23/2001 : mdb - Created.
//  Desc: centralized instantiation of templates needed for this directory.
// ****************************************************************************

#include "dc_standard.h"


//
// This is one model of template instantiation -- all templates we
// need for the current subdirectory are instantiated here.  The
// obvious problem is template args cannot be static to a .cpp file.
// If any c++ compiler ever supports the template export keyword, this
// could all be easier.  To reduce code bloat, we instantiate all
// needed templates here, and tell the compiler to not do it
// automatically.
//
#if defined(HAVE_INSTANTIATIONS)

// for dc_configinfo.cpp ...
#include "dc_configinfo.h"
template class DArray<ConfigInfo_Entry>;
template class DArray<ConfigInfo_Section>;
template class DArray<char*>;
template class DArray<int>;

// for dc_memory.cpp ...
#include "dc_memory.h"
template class SLList<MemBuf>;

// for dc_metric.cpp ...
template class DArray<double>;

// for dc_namevalue.cpp ...
#include "dc_namevalue.h"
template class DArray<NameValue_Entry_t>;

// for dc_queue.cpp backward compatibility with non-template version ...
#include "dc_queue.h"
#include "dc_queue.cpp"
template class DC_QueueT<void*>;

#endif /* HAVE_INSTANTIATIONS */


// ****************************************************************************
